#include <sys/socket.h>
#include <netinet/in.h>
#include <linux/netlink.h>
#include <linux/rtnetlink.h>
#include <poll.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

void *getsrcaddr(void *dst,int dstlen)
{
	int fd;
	int x;
	int family;
	struct nlmsghdr *h;
	struct rtmsg *r;
	struct rtattr *a;
	struct pollfd p;
	struct sockaddr_nl addr;
	void *s=NULL;
	union
	{
		struct sockaddr_in a4;
		struct sockaddr_in6 a6;
	} *src=NULL;
	unsigned char bfr[1024];

	memset(bfr,0,sizeof(struct nlmsghdr)+sizeof(struct rtmsg)+
		sizeof(struct rtattr));
	h=(struct nlmsghdr *)bfr;
	r=(struct rtmsg *)NLMSG_DATA(h);
	if(dstlen==sizeof(struct sockaddr_in6)&&
		((struct sockaddr_in6 *)dst)->sin6_family==AF_INET6)
			family=AF_INET6;
	else if(dstlen==sizeof(struct sockaddr_in)&&
		((struct sockaddr_in *)dst)->sin_family==AF_INET)family=AF_INET;
	else goto err1;
	if((fd=socket(PF_NETLINK,SOCK_RAW|SOCK_CLOEXEC|SOCK_NONBLOCK,
		NETLINK_ROUTE))==-1)goto err1;
	x=32768;
	if(setsockopt(fd,SOL_SOCKET,SO_SNDBUF,&x,sizeof(x)))goto err2;
	x=1048576;
	if(setsockopt(fd,SOL_SOCKET,SO_RCVBUF,&x,sizeof(x)))goto err2;
	memset(&addr,0,sizeof(addr));
	addr.nl_family=AF_NETLINK;
	addr.nl_pid=getpid();
	if(bind(fd,(struct sockaddr *)&addr,sizeof(addr))==-1)goto err2;
	h->nlmsg_len=NLMSG_LENGTH(sizeof(struct rtmsg));
	h->nlmsg_type=RTM_GETROUTE;
	h->nlmsg_flags=NLM_F_REQUEST;
	h->nlmsg_pid=getpid();
	r->rtm_family=family;
	r->rtm_type=RTN_UNSPEC;
	a=RTM_RTA(r);
	a->rta_type=RTA_DST;
	switch(family)
	{
	case AF_INET:
		r->rtm_dst_len=32;
		a->rta_len=RTA_LENGTH(4);
		memcpy(RTA_DATA(a),&((struct sockaddr_in *)dst)->sin_addr,4);
		h->nlmsg_len=NLMSG_ALIGN(h->nlmsg_len)+RTA_ALIGN(RTA_LENGTH(4));
		break;

	case AF_INET6:
		r->rtm_dst_len=128;
		a->rta_len=RTA_LENGTH(16);
		memcpy(RTA_DATA(a),&((struct sockaddr_in6 *)dst)->sin6_addr,
			16);
		h->nlmsg_len=NLMSG_ALIGN(h->nlmsg_len)+
			RTA_ALIGN(RTA_LENGTH(16));
		break;
	}

	if(send(fd,bfr,h->nlmsg_len,0)!=h->nlmsg_len)goto err2;
	p.fd=fd;
	p.events=POLLIN;
	if(poll(&p,1,1000)!=1||!(p.revents&POLLIN))goto err2;
	if((x=recv(fd,bfr,sizeof(bfr),0))<sizeof(struct nlmsghdr)+
		sizeof(struct rtattr)||x!=h->nlmsg_len)goto err2;

	if(h->nlmsg_type!=RTM_NEWROUTE||r->rtm_family!=family)goto err2;

	for(x-=NLMSG_LENGTH(sizeof(struct rtmsg));RTA_OK(a,x);a=RTA_NEXT(a,x))
		switch(a->rta_type)
	{
	case RTA_SRC:
		if(s)break;
	case RTA_PREFSRC:
		s=RTA_DATA(a);
		break;
	}
	if(!s)goto err2;

	switch(family)
	{
	case AF_INET:
		if(!(src=malloc(sizeof(struct sockaddr_in))))goto err2;
		memset(src,0,sizeof(struct sockaddr_in));
		src->a4.sin_family=AF_INET;
		memcpy(&src->a4.sin_addr,s,4);
		break;

	case AF_INET6:
		if(!(src=malloc(sizeof(struct sockaddr_in6))))goto err2;
		memset(src,0,sizeof(struct sockaddr_in6));
		src->a6.sin6_family=AF_INET6;
		memcpy(&src->a6.sin6_addr,s,16);
		break;
	}

err2:	close(fd);
err1:	return src;
}
