/*
 * This file is part of the vpnd2 project
 *
 * (C) 2017 Andreas Steinmetz, ast@domdv.de
 * The contents of this file is licensed under the GPL version 2 or, at
 * your choice, any later version of this license.
 */

#ifndef PARSE_H_INCLUDED
#define PARSE_H_INCLUDED

#define SERVER	0
#define CLIENT	1

struct listen
{
	struct listen *next;
	void *fn;
	void *addr;
	unsigned int port;
	unsigned int proto;
	unsigned int rtp;
	unsigned int small;
	unsigned int strip;
};

struct config
{
	struct config *next;
	struct global *global;
	char *keyfile;
	char *script;
	char *authfile[2];
	char *server;
	char *sockshost;
	char *proxyhost;
	char *helpercmd;
	char *helpercnf;
	unsigned int mode;
	unsigned int dnstimeout;
	unsigned int conntimeout;
	unsigned int port;
	unsigned int proto;
	unsigned int setuplimit;
	unsigned int minbits;
	unsigned int maxbits;
	unsigned int sigminbits;
	unsigned int sigmaxbits;
	unsigned int x25519;
	unsigned int secp;
	unsigned int brainpool;
	unsigned int sigsecp;
	unsigned int sigbrainpool;
	unsigned int rohc;
	unsigned int rohccid;
	unsigned int prefv4;
	unsigned int delay;
	unsigned int rekey;
	unsigned int sendbuf;
	unsigned int maxseg;
	unsigned int tcpdefer;
	unsigned int frag;
	unsigned int rtp;
	unsigned int small;
	unsigned int strip;
	unsigned int paranoia;
	unsigned int noop;
	unsigned int socksport;
	unsigned int proxyport;
	unsigned int rekeyfail;
	unsigned int connection;
	unsigned int srcaddr;
};

struct global
{
	char *keyfile;
	char *user;
	char *newpub;
	char *revoke;
	char *pidfile;
	void *glob;
	struct listen *sockets;
	struct config *cfg;
	unsigned int setuptimeout;
	unsigned int setuplimit;
	unsigned int minbits;
	unsigned int maxbits;
	unsigned int sigminbits;
	unsigned int sigmaxbits;
	unsigned int x25519;
	unsigned int secp;
	unsigned int brainpool;
	unsigned int sigsecp;
	unsigned int sigbrainpool;
	unsigned int isserver;
	unsigned int isclient;
	unsigned int sysadm;
	unsigned int caps;
	unsigned int ugid;
	unsigned int pendinglimit;
	unsigned int keepalive;
	unsigned int realtime;
	unsigned int maxdata;
	unsigned int datapad;
	unsigned int sendbuf;
	unsigned int maxseg;
	unsigned int tcpdefer;
	unsigned int tcpuser;
	unsigned int frag;
	unsigned int alt;
	unsigned int portmin;
	unsigned int portmax;
	int cefd;
	int sefd;
};

extern int parseconfig(char *fn,struct global *glob,void *gctx,int cefd,
	int sefd);
extern void freeconfig(struct global *glob);

#endif
