/*
 * This file is part of the vpnd2 project
 *
 * (C) 2017 Andreas Steinmetz, ast@domdv.de
 * The contents of this file is licensed under the GPL version 2 or, at
 * your choice, any later version of this license.
 */

#ifndef PROTO_H_INCLUDED
#define PROTO_H_INCLUDED

#define TCP		0x00
#define SCTP_OO		0x01
#define SCTP_OM		0x02
#define UDP		0x03
#define UDPLITE		0x04
#define TCP_RTP		0x80
#define SCTP_OO_RTP	0x81
#define SCTP_OM_RTP	0x82
#define UDP_RTP		0x83
#define UDPLITE_RTP	0x84
#define SOCKS5		0x100
#define PROXY		0x101
#define HELPER		0x102
#define PKTHELPER	0x103
#define UNIX		0x104
#define PKTUNIX		0x105

#define CONTROL		0
#define DATAUNCOMP	1
#define ROHCDATA	2
#define ROHCFEEDBK	3

struct conn
{
	int proto;
	int fd;
	int curve;
	int keepalive;
	int rekey;
	int noop;
	int packet;
	int dstlen;
	void *rtp;
	void *dst;
	struct crypto_keys *keys;
	struct crypto_conn *conn[2];
};

#endif
