#!/bin/sh
mkkeys()
{
	rm -f client-*.key client-*.pub server-*.key server-*.pub
	for i in secp256r1 secp384r1 secp521r1 brainpoolp256r1 \
		brainpoolp384r1 brainpoolp512r1
	do
		../../vpnd2 -k $i client-$i
		../../vpnd2 -k $i server-$i
	done
}
rmkeys()
{
	rm -f client-*.key client-*.pub server-*.key server-*.pub
}
calc()
{
if [ ! -f /tmp/vpnd2.1 -o ! -f /tmp/vpnd2.2 ]
then
	res="failed"
else
	let res=`cat /tmp/vpnd2.2`-`cat /tmp/vpnd2.1`
	len=${#res}
	case $len in
	1)	res="0.000000000"
		;;
	1)	res="0.00000000$res"
		;;
	2)	res="0.0000000$res"
		;;
	3)	res="0.000000$res"
		;;
	4)	res="0.00000$res"
		;;
	5)	res="0.0000$res"
		;;
	6)	res="0.000$res"
		;;
	7)	res="0.00$res"
		;;
	8)	res="0.0$res"
		;;
	9)	res="0.$res"
		;;
	*)	rem=${res:-9:9}
		let val=len-9
		val=${res:0:$val}
		res="$val.$rem"
		;;
	esac
fi
echo proto $1 ephemeral $2 auth $3 $4: $res 
}
mkkeys
for i in x25519 secp256r1 secp384r1 secp521r1 brainpoolp256r1 brainpoolp384r1 brainpoolp512r1
do
	for j in secp256r1 secp384r1 secp521r1 brainpoolp256r1 \
		brainpoolp384r1 brainpoolp512r1
	do
		./server.sh $i-$j > /dev/null 2>&1 &
		svr=$!
		sleep 1
		for k in optimistic paranoia
		do
			for l in helper pkthelper sctpom sctpoo tcp udp udplite
			do
				rm -f /tmp/vpnd2.1 /tmp/vpnd2.2
				./client.sh $l-$i-$j-$k > /dev/null 2>&1 &
				cln=$!
				x=0
				while [ $x -lt 30 ]
				do
					usleep 100000
					if [ -f /tmp/vpnd2.2 ]
					then
						break
					fi
					let x=$x+1
				done
				kill $cln
				calc $l $i $j $k
				wait $cln
			done
			echo ""
		done
		kill $svr
		wait $svr
	done
done
rm -f /tmp/vpnd2.1 /tmp/vpnd2.2
rmkeys
