#!/bin/sh

wrongclnkey()
{
rm -rf *.pub *.key /tmp/vpnd2.1 /tmp/vpnd2.2
../../vpnd2 -k secp256r1 server
../../vpnd2 -k secp256r1 client
../../vpnd2 -k secp256r1 client-bad
mv client-bad.pub client.pub
rm client-bad.key
./server.sh > /dev/null 2>&1 &
svr=$!
./client.sh > /dev/null 2>&1 &
cln=$!
sleep 2
kill -TERM $cln > /dev/null 2>&1
kill -TERM $svr > /dev/null 2>&1
wait $cln
wait $svr
if [ -f /tmp/vpnd2.1 -o -f /tmp/vpnd2.2 ]
then
	echo "wrong client public key test failed"
	return 1
fi
return 0
}

lowclnkey()
{
rm -rf *.pub *.key
../../vpnd2 -k secp256r1 client
touch /tmp/vpnd2.1
chown nobody:nobody /tmp/vpnd2.1
./client.sh 384 > /dev/null 2>&1 &
cln=$!
sleep 2
kill -TERM $cln > /dev/null 2>&1
wait $cln
if [ ! -f /tmp/vpnd2.1 ]
then
	echo "wrong client key type test failed"
	return 1
fi
return 0
}

highclnkey()
{
rm -rf *.pub *.key
../../vpnd2 -k secp521r1 client
touch /tmp/vpnd2.1
chown nobody:nobody /tmp/vpnd2.1
./client.sh > /dev/null 2>&1 &
cln=$!
sleep 2
kill -TERM $cln > /dev/null 2>&1
wait $cln
if [ ! -f /tmp/vpnd2.1 ]
then
	echo "wrong client key type test failed"
	return 1
fi
return 0
}

badclnkey()
{
rm -rf *.pub *.key
../../vpnd2 -k brainpoolp256r1 client
touch /tmp/vpnd2.1
chown nobody:nobody /tmp/vpnd2.1
./client.sh > /dev/null 2>&1 &
cln=$!
sleep 2
kill -TERM $cln > /dev/null 2>&1
wait $cln
if [ ! -f /tmp/vpnd2.1 ]
then
	echo "wrong client key type test failed"
	return 1
fi
return 0
}

higheclnkey()
{
rm -rf *.pub *.key /tmp/vpnd2.1 /tmp/vpnd2.2
../../vpnd2 -k secp256r1 server
../../vpnd2 -k secp256r1 client
./server.sh > /dev/null 2>&1 &
svr=$!
./client.sh e384 > /dev/null 2>&1 &
cln=$!
sleep 2
kill -TERM $cln > /dev/null 2>&1
kill -TERM $svr > /dev/null 2>&1
wait $cln
wait $svr
if [ -f /tmp/vpnd2.1 -o -f /tmp/vpnd2.2 ]
then
	echo "wrong client ephemeral key test failed"
	return 1
fi
return 0
}

wrongsvrkey()
{
rm -rf *.pub *.key /tmp/vpnd2.1 /tmp/vpnd2.2
../../vpnd2 -k secp256r1 server
../../vpnd2 -k secp256r1 server-bad
../../vpnd2 -k secp256r1 client
mv server-bad.pub server.pub
rm server-bad.key
./server.sh > /dev/null 2>&1 &
svr=$!
./client.sh > /dev/null 2>&1 &
cln=$!
sleep 2
kill -TERM $cln > /dev/null 2>&1
kill -TERM $svr > /dev/null 2>&1
wait $cln
wait $svr
if [ -f /tmp/vpnd2.1 -o -f /tmp/vpnd2.2 ]
then
	echo "wrong server public key test failed"
	return 1
fi
return 0
}

lowsvrkey()
{
rm -rf *.pub *.key
../../vpnd2 -k secp256r1 server
touch /tmp/vpnd2.2
chown nobody:nobody /tmp/vpnd2.2
./server.sh 384 > /dev/null 2>&1 &
svr=$!
sleep 2
kill -TERM $svr > /dev/null 2>&1
wait $svr
if [ ! -f /tmp/vpnd2.2 ]
then
	echo "wrong server key type test failed"
	return 1
fi
return 0
}

highsvrkey()
{
rm -rf *.pub *.key
../../vpnd2 -k secp521r1 server
touch /tmp/vpnd2.2
chown nobody:nobody /tmp/vpnd2.2
./server.sh > /dev/null 2>&1 &
svr=$!
sleep 2
kill -TERM $svr > /dev/null 2>&1
wait $svr
if [ ! -f /tmp/vpnd2.2 ]
then
	echo "wrong server key type test failed"
	return 1
fi
return 0
}

badsvrkey()
{
rm -rf *.pub *.key
../../vpnd2 -k brainpoolp256r1 server
touch /tmp/vpnd2.2
chown nobody:nobody /tmp/vpnd2.2
./server.sh > /dev/null 2>&1 &
svr=$!
sleep 2
kill -TERM $svr > /dev/null 2>&1
wait $svr
if [ ! -f /tmp/vpnd2.2 ]
then
	echo "wrong server key type test failed"
	return 1
fi
return 0
}

highesvrkey()
{
rm -rf *.pub *.key /tmp/vpnd2.1 /tmp/vpnd2.2
../../vpnd2 -k secp256r1 server
../../vpnd2 -k secp256r1 client
./server.sh e384 > /dev/null 2>&1 &
svr=$!
./client.sh > /dev/null 2>&1 &
cln=$!
sleep 2
kill -TERM $cln > /dev/null 2>&1
kill -TERM $svr > /dev/null 2>&1
wait $cln
wait $svr
if [ -f /tmp/vpnd2.1 -o -f /tmp/vpnd2.2 ]
then
	echo "wrong server ephemeral key test failed"
	return 1
fi
return 0
}

r=0
rm -rf *.pub *.key /tmp/vpnd2.1 /tmp/vpnd2.2
wrongclnkey || r=1
wrongsvrkey || r=1
lowclnkey || r=1
highclnkey || r=1
badclnkey || r=1
higheclnkey || r=1
lowsvrkey || r=1
highsvrkey || r=1
badsvrkey || r=1
highesvrkey || r=1
rm -rf *.pub *.key /tmp/vpnd2.1 /tmp/vpnd2.2
exit $r
