#!/bin/sh
export PATH=/sbin:/bin:/usr/sbin:/usr/bin:/usr/local/sbin:/usr/local/bin
dotest()
{
	echo ""
	echo "=============================================================="
	echo "$1"
	echo "=============================================================="
	echo ""
	if [ "$2" != "" ]
	then
		ip netns exec vpncln$2 \
			netperf -4 -H 192.168.0.1 -I95,15 -i 100,10 -l 10
		return
	fi
	echo "rohc disabled"
	echo ""
	ip netns exec vpncln1 netperf -4 -H 192.168.0.1 -I95,15 -i 100,10 -l 10
	ip netns exec vpncln3 netperf -4 -H 192.168.0.1 -I95,15 -i 100,10 -l 10
	echo ""
	echo "rohc enabled (if possible)"
	echo ""
	ip netns exec vpncln2 netperf -4 -H 192.168.0.1 -I95,15 -i 100,10 -l 10
	ip netns exec vpncln4 netperf -4 -H 192.168.0.1 -I95,15 -i 100,10 -l 10
}
cleanup()
{
killproc `which netserver`
rm -f client[1-4].key client[1-4].pub server.key server.pub
}
cleanup
trap cleanup SIGINT SIGHUP SIGTERM
for i in client1 client2 client3 client4 server
do
	../../vpnd2 -k secp256r1 $i
done
./server.sh > /dev/null 2>&1 &
svr=$!
sleep 1
ip netns exec vpnsvr netserver > /dev/null 2>&1
if [ "$1" != "" ]
then
	if [ -f client-$1.conf ]
	then
		./client.sh $1 > /dev/null 2>&1 &
		cln=$!
		sleep 1
		dotest $1 $2
		kill $cln
		wait $cln
	fi
else
	for i in helper pkthelper sctpom sctpoo tcp udplite udp
	do
		for j in '' -rtp
		do
			for k in std small strip small-strip
			do
				if [ -f client-$i$j-$k.conf ]
				then
					./client.sh $i$j-$k > /dev/null 2>&1 &
					cln=$!
					sleep 1
					dotest $i$j-$k
					kill $cln
					wait $cln
				fi
			done
		done
	done
fi
kill $svr
wait $svr
cleanup
