/*
 * This file is part of the vpnd2 project
 *
 * (C) 2017 Andreas Steinmetz, ast@domdv.de
 * The contents of this file is licensed under the GPL version 2 or, at
 * your choice, any later version of this license.
 */

#include <net/if.h>
#include <linux/if_tun.h>
#include <sys/ioctl.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include "misc.h"
#include "tun.h"

COLD struct tun *opentun(void)
{
	struct tun *tun;
	struct ifreq ifr;

	if(!(tun=malloc(sizeof(struct tun))))goto err1;
	if((tun->fd=open("/dev/net/tun",O_RDWR|O_CLOEXEC|O_NONBLOCK))==-1)
		goto err2;
	memset(&ifr,0,sizeof(ifr));
	ifr.ifr_flags=IFF_TUN|IFF_NO_PI;
	if(ioctl(tun->fd,TUNSETIFF,(void *)&ifr)<0)goto err3;
	if(!(tun->dev=strdup(ifr.ifr_name)))goto err3;
	return tun;

err3:	close(tun->fd);
err2:	free(tun);
err1:	return NULL;
}

COLD void closetun(struct tun *tun)
{
	close(tun->fd);
	free(tun->dev);
	free(tun);
}
